from app.api_data.platform_order.order_util import *
from model.DataBaseUtils import MysqlUtils
from concurrent.futures import ThreadPoolExecutor
from model.DingTalkUtils import DingTalkDecorators
from app.api_data.platform_order.audio_qiyue import AudioQiyue
from app.api_data.platform_order.youshuge import get_youshuge_order_task
from app.api_data.platform_order.yuewen import get_yuewen_order_task
from app.api_data.platform_order.yangguang import yangguang
from app.api_data.platform_order.QiYue import get_qiyue_order_task
import logging

db = MysqlUtils()


def get_new_account(plactform):
    data = db.quchen_text.getData(
        f"select text from order_account_text where platform='{plactform}' and create_time>='{du.get_n_days(-1)}'")
    new_data = []
    for i in data:
        new_data.append(i[0].replace('\n', '').split(","))
    return new_data


@DingTalkDecorators("花生")
def huasheng(start=None, end=None):
    logging.info('花生订单数据拉取,开始')
    if start is None:
        start = end = du.getNow()
    accounts = get_account("花生")
    if len(accounts) == 0:
        return
    else:
        logging.info(f'花生有账号{len(accounts)}个')
    # 花生有请求限制 不用多线程
    for account in accounts:
        get_hs_order_task(start, end, account)
    logging.info('花生订单数据拉取,结束')


@DingTalkDecorators("七悦")
def qiyue(start=None, end=None, new=None):
    logging.info('七悦订单数据拉取,开始')
    if start is None:
        start = end = du.getNow()
    accounts = get_account("七悦")
    if len(accounts) == 0:
        return
    else:
        logging.info(f'七悦有账号{len(accounts)}个')
    for account in accounts:
        get_qiyue_order_task(start, end, account)
    logging.info('七悦订单数据拉取,结束')


@DingTalkDecorators("文鼎")
def wending(start=None, end=None, new=None):
    logging.info('文鼎订单数据拉取,开始')
    if start is None:
        start = end = du.getNow()

    accounts = get_account("文鼎") if new is None else get_new_account('文鼎')
    if len(accounts) == 0:
        return
    else:
        logging.info(f'文鼎有账号{len(accounts)}个')
    for account in accounts:
        get_wd_order_task(start, end, account)
    logging.info('文鼎订单数据拉取,结束')


@DingTalkDecorators("国风")
def guofeng(start=None, end=None, new=None):
    if start:
        start = start if start > '2021-07-09' else '2021-07-09'
    logging.info('国风订单数据拉取,开始')
    if start is None:
        start = end = du.getNow()

    accounts = get_account("国风") if new is None else get_new_account('国风')
    if len(accounts) == 0:
        return
    else:
        logging.info(f'国风有账号{len(accounts)}个')
    for account in accounts:
        get_gf_order_task(start, end, account)
    logging.info('国风订单数据拉取,结束')


@DingTalkDecorators("掌读")
def zhangdu(start=None, end=None, new=None):
    logging.info('掌读订单数据拉取,开始')
    if start is None:
        start = end = du.getNow()

    accounts = get_account("掌读")
    if len(accounts) == 0:
        return
    else:
        logging.info(f'掌读有账号{len(accounts)}个')
    for account in accounts:
        get_zd_order_task(start, end, account)
    logging.info('掌读订单数据拉取,结束')


@DingTalkDecorators("掌中云")
def zhangzhongyun(start=None, end=None, new=None):
    logging.info('掌中云订单数据拉取,开始')
    if start is None:
        start = du.getNow()
        end = du.get_n_days(1)

    executor = ThreadPoolExecutor(max_workers=5)
    accounts = get_account("掌中云")
    if len(accounts) == 0:
        return
    else:
        logging.info(f'掌中云有账号{len(accounts)}个')
    for account in accounts:
        executor.submit(
            get_zzy_order_task, start, end, account)
    executor.shutdown()
    logging.info('掌中云订单数据拉取,结束')


@DingTalkDecorators("阅文")
def yueweng(start=None, end=None):
    logging.info('阅文订单数据拉取,开始')
    if start is None:
        start = end = du.getNow()

    executor = ThreadPoolExecutor(max_workers=5)
    accounts = get_account("阅文")
    if len(accounts) == 0:
        return
    else:
        logging.info(f'阅文有账号{len(accounts)}个')
    for account in accounts:
        executor.submit(get_yuewen_order_task, start, end, account)
    executor.shutdown()
    logging.info('阅文订单数据拉取,结束')


@DingTalkDecorators("七悦有声")
def qiyueyousheng(start=None, end=None):
    logging.info('七悦有声订单数据拉取,开始')
    if start is None:
        start = end = du.getNow()
    accounts = get_account("七悦有声")
    if len(accounts) == 0:
        return
    else:
        logging.info(f'七悦有声有账号{len(accounts)}个')
    for account in accounts:
        AudioQiyue().get_order(start, end, account)
    logging.info('七悦有声订单数据拉取,结束')


@DingTalkDecorators("悠书阁")
def youshuge(start=None, end=None):
    logging.info('悠书阁订单数据拉取,开始')
    if start is None:
        start = end = du.getNow()

    executor = ThreadPoolExecutor(max_workers=5)
    accounts = get_account("悠书阁")
    if len(accounts) == 0:
        return
    else:
        logging.info(f'悠书阁有账号{len(accounts)}个')
    for account in accounts:
        executor.submit(get_youshuge_order_task, start, end, account)
    executor.shutdown()
    logging.info('悠书阁订单数据拉取,结束')


def yestoday():
    st = et = du.get_n_days(-1)
    huasheng(st, et)
    qiyue(st, et)
    qiyueyousheng(st, et)
    wending(st, et)
    zhangdu(st, et)
    zhangzhongyun(st, et)
    yueweng(st, et)
    youshuge(st, et)
    yangguang(st, et)


if __name__ == '__main__':
    # zhangzhongyun()
    # yangguang()
    # huasheng("2021-04-12",'2021-05-10')
    yueweng(du.get_n_days(-3), du.get_n_days(0))
    # qiyue('2020-11-01', '2021-06-03')
