from app.etl import data_stat_run
from model.DateUtils import DateUtils
from app.crontab_task import task
from model.DingTalkUtils import DingTalkUtils
from logging import handlers
import time
import logging


if __name__ == '__main__':
    logging.basicConfig(
        handlers=[
            logging.handlers.RotatingFileHandler('./log/hourlyRun.log',
                                                 maxBytes=10 * 1024 * 1024,
                                                 backupCount=5,
                                                 encoding='utf-8')
            , logging.StreamHandler()  # 供输出使用
        ],
        level=logging.INFO,
        format="%(asctime)s - %(levelname)s %(filename)s %(funcName)s %(lineno)s - %(message)s"
    )
    du = DateUtils()
    st = time.time()

    logging.info('订单与消耗数据拉取,开始')
    # 订单数据和消耗数据拉取
    task.hourly()
    logging.info('订单与消耗数据拉取,结束')

    logging.info('订单与消耗数据处理,开始')
    # 数据处理
    data_stat_run.hourly()
    logging.info('订单与消耗数据处理,结束')


    if int(time.time()-st)>1500:
        DingTalkUtils().send(f"消耗小时任务耗时{int(time.time()-st)}秒",phone="15168342316")






